<?php

/**
 * periodos_rango_proy actions.
 *
 * @package    nomina
 * @subpackage periodos_rango_proy
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class periodos_rango_proyActions extends sfActions {

    /**
     * Executes executeList action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.id_anhos, mes.id_meses ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            //PARAMETROS
            $id_anhos = $request['id_anhos'];

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            //Tome solo periodos cerrados - 20210512::LAVILA
            $consulta_sql = <<<EOD
SELECT
tab0.id_anhos,
mes.id_meses,
mes.descripcion as mes,
0 as estado,
0 as activo

FROM anhos tab0

left join meses mes
on mes.id_meses != 0

where
tab0.id_anhos = $id_anhos
and (tab0.id_anhos,mes.id_meses) not in (

    SELECT DISTINCT
    per.id_anhos,
    per.id_meses
    
    FROM no_concepto_periodo tab0
    
    join no_periodo_v per
    on per.id_periodo = tab0.periodo
    
    where
    per.id_anhos = $id_anhos
    and per.estado = 0

)
EOD;


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             * Se adiciona el año para que sea solo los del año fin del filtro - 20190705
             */
            $sql = <<<EOD
select count(*) as count from (

$consulta_sql    

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

$consulta_sql   
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[periodos_rango_proy] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[periodos_rango_proy] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
